#!/usr/bin/perl

require "base.pl";
require "cart_functions.pl";
require "buttons.pl";
if ($form->{form}){
  if ($form->{form} eq "change_shipto"){
    if ($form->{add_shipto} == 1){
       &changeshipto;
       &confirm;
    } else {
       &defaultshipto;
       &confirm;
    }
  } elsif ($form->{form} eq "confirm"){
     &process;
  } else {
    $form->error("We are sorry, but your request could not be completed.");
  }
}
else {
  &confirm_ship;
}

&print_screen;

1;

sub confirm_ship {
  &defaultshipto;
  $form->{IN} = "shipto.html";
}

sub changeshipto {
  $form->{new_ship} = qq|
	<input type=hidden name=add_shipto value='1'>
  |;
  for (qw(address1 address2)){
    $form->{new_ship} .= qq|
	<input type=hidden name='$_' value='|.$form->{$_}.qq|'>
    |;
  }
  for (qw(name city state zipcode phone fax email)){
    $form->{new_ship} .= qq|
	<input type=hidden name='$_' value='|.$form->{"c_$_"}.qq|'>
    |;
  }
}

sub defaultshipto {
  $form->{db} = 'customer';
  $form->{c_login} = $form->{login};
  use SL::CT;
  CT->search(\%myconfig, \%$form);
  foreach (keys %{$form->{CT}[0]}){
    $form->{"c_$_"} = ${$form->{CT}[0]}{$_} unless $form->{"c_$_"};
  }
  foreach (qw(address1 address2)){
    $form->{$_} = $form->{"c_$_"};
  }
}

sub confirm {
  &get_full_cart;
  $form->{IN} = "confirm.html";
}


sub process {
  $form->{new_total} = $form->{total};
  &defaultshipto;
  if ($form->{zipcode}){
     $form->{c_zipcode} = $form->{zipcode};
  }
  &get_full_cart;
  $form->{total} = $form->{new_total} # Probably postage didn't work
	unless $form->{new_total} > $form->{total}; 
  &create_order;
  require "$myconfig{cart_type}.pl";
  $form->{IN} = "processing.html";
}

sub create_order{
  &get_customer_id;
  $i = 0;
  for (@{$form->{qty}}){
    for (qw(qty sellprice description)){ # Line items
       $j = $i + 1;
       $form->{"$_"."_$j"} = ${$form->{$_}}[$i];
       $form->{"parts_id_$j"} = ${$form->{id}}[$i];
    }
    ++$i;
  }
  ++$i;
  ++$form->{rowcount};
  $form->{"id_$i"} = $myconfig{s_h_parts_id};
  $form->{"qty_$i"} = $form->{postage};
  $form->{"sellprice_$i"} = '1';
  $form->{"description_$i"} = "Shipping and Handling";
  $form->{notes} = "Online Order $form->{session_id}";
  $form->{transdate} = $form->current_date(\%myconfig);
  $form->{ids} = $form->{id};
  $form->{id} = 0;
  $form->{ordnumber} = "ol$form->{session_id}";
  use SL::OE;
  $form->{type} = "sales_order";
  for (qw(name address1 address2 city state zipcode)){
     $form->{"shipto$_"} = $form->{$_};
  }
  OE->save(\%myconfig, \%$form);
  my $dbh = $form->dbconnect(\%myconfig);
  $form->add_shipto($dbh, $form->{id});
  $dbh->disconnect;
  $form->{id} = $form->{ids};
}
