# Variables
# USPS UserId & Password
# Origination ZipCode, Item weight in Lb & Oz
# Service Types - Express, First Class, Priority, Parcel, Library, Media

use LWP::UserAgent;
my $addr = 'http://Production.ShippingAPIs.com/ShippingAPI.dll';
my $userid = 'USPS USER ID';
my $pswd = 'USPS USER PASSWORD';

# request(s) Package(s)

my $rateReqDoc = qq~   
<RATEREQUEST PASSWORD='\"$pswd\"' USERID='\"$userid\"'>

<PACKAGE id='\"0\"'><BR>  <SERVICE>Express</SERVICE>
<ZIPORIGINATION>YOUR ZIPCODE</ZIPORIGINATION>
<ZIPDESTINATION>$INPUT{'zipcode'}</ZIPDESTINATION>
<POUNDS>$lb</POUNDS>
<OUNCES>$oz</OUNCES>
<CONTAINER>None</CONTAINER>
<SIZE>Regular</SIZE>
<MACHINABLE>False</MACHINABLE>
</PACKAGE>

<PACKAGE id='\"1\"'>
<SERVICE>Priority</SERVICE>
<ZIPORIGINATION>YOUR ZIPCODE</ZIPORIGINATION>
<ZIPDESTINATION>$INPUT{'zipcode'}</ZIPDESTINATION>
<POUNDS>$lb</POUNDS>
<OUNCES>$oz</OUNCES>
<CONTAINER>0-1096</CONTAINER>
<SIZE>Regular</SIZE>
<MACHINABLE>False</MACHINABLE>
</PACKAGE>

<PACKAGE id='\"2\"'>
<SERVICE>Parcel</SERVICE>
<ZIPORIGINATION>YOUR ZIPCODE</ZIPORIGINATION>
<ZIPDESTINATION>$INPUT{'zipcode'}</ZIPDESTINATION>
<POUNDS>$lb</POUNDS>
<OUNCES>$oz</OUNCES>
<CONTAINER>None</CONTAINER>
<SIZE>Regular</SIZE>
<MACHINABLE>False</MACHINABLE>
</PACKAGE>

</RATEREQUEST>
~;

# send request with lwp
my $ua = LWP::UserAgent->new;
$ua->timeout(2);
$ua->agent("AgentName/0.1 " . $ua->agent);
my $req = HTTP::Request->new(POST =>$addr);
$req->content_type('application/x-www-form-urlencoded');
$req->content('API=Rate&XML=' . $rateReqDoc);
my $response = $ua->request($req);

# if response, proceed
if ($response->is_success) {
my $resp = $response->content;

# activate xml
use XML::Simple;
my $xml = eval{XMLin($resp)}; #set lwp response to xml

my (@PKGS,$i);
if (ref($xml->{Package}) eq "ARRAY") {
 @PKGS = (@{$xml->{Package}}); #set array to xml
} else {
 @PKGS = ($xml->{Package}); #set hash to xml
}

my $n = (scalar(@PKGS)); #count the number of packages - for debugg mostly
print "Displaying canned response(s) to $n Package(s) < HR > ";

my $i=0;
foreach (@PKGS) {
 # look for errors
 if (exists(${$_}{'Error'})) {
  
  # error, probably not applicable rate to skip
  
 } else {
  # print actual record
  unless(${$_}{'Postage'}){ next; }
  
  my $postage = ${$_}{'Postage'};
  $postage += $postage * ($config{'ship_base'} / 100);
  $postage = sprintf ("%.2f",$postage);
  
  $cnt++;
  print qq~
  <INPUT type=radio value="USPS::${$_}{'Service'}-$postage" name=shipping_type$gt; USPS - ${$_}{'Service'}: \$$postage   ~; 
 }
 $scnt++;
 $i++;   
}
 # END USPS DOMESTIC RATES
}

}

The Code (International)

# Note: be sure to use full country name for rates

# Variables
# USPS UserId & Password
# Origination ZipCode, Item weight in Lb & Oz
# Service Types - Automatically called from server

my $lb = int($shipping_wgt);
my $oz = int((($shipping_wgt - (int($shipping_wgt))) * 16));

my $usps;  
use LWP::UserAgent;
 
my $addr = 'http://Production.ShippingAPIs.com/ShippingAPI.dll';
my $userid = 'USPS USER ID';
my $pswd = 'USPS USER PASSWORD'; 

# request(s) Package(s)

my $rateReqDoc = qq~  
<INTLRATEREQUEST PASSWORD="$pswd" USERID="$userid">
<PACKAGE id=0>
<POUNDS>$lb</POUNDS>
<OUNCES>$oz</OUNCES>
<MAILTYPE>Package</MAILTYPE>
<COUNTRY>$cntry</COUNTRY>
</PACKAGE>
</INTLRATEREQUEST>
~;

# send request
my $ua = LWP::UserAgent->new;
$ua->timeout(2);
$ua->agent("AgentName/0.1 " . $ua->agent);
my $req = HTTP::Request->new(POST =>$addr);
$req->content_type('application/x-www-form-urlencoded');
$req->content('API=IntlRate&XML=' . $rateReqDoc);
my $response = $ua->request($req);

if ($response->is_success) {
my $resp = $response->content;

# use parser to extract elements
# reference parsed hash/arrays directly without data::dumper
# Must know the XML data structure to pull this off, levels of hash references

use XML::Simple;

# eval if preventing die in parser
my $xml = eval{XMLin($resp)};

 my (@PKGS,$i);    
 if (ref($xml->{Package}) eq "ARRAY") {
  @PKGS = (@{$xml->{Package}}); 
 } else {
  @PKGS = ($xml->{Package});
 }

 my $n = (scalar(@PKGS));
 print "Displaying canned response(s) to $n Package(s) $lgt;HR NOSHADE> "; 
 
my $i=0;   
foreach (@PKGS) {
 my (@SRVS,$c); 
 # look for errors
 
 if (exists(${$_}{'Error'})) {     
  
  # error, probably not applicable rate to skip     
 
  print " <LI>PKG $i : Outcome From Test Package ${$_}{'ID'} Error";
  print " <LI>${${$_}{'Error'}}{'Description'} ($shipping_wgt lbs)";
 
 } else {
  
  print qq~
  $cntry shipping regions: ${$_}{'AreasServed'}
  <HR noshade>
  ~;
  
  if (ref($xml->{Package}->{Service}) eq "ARRAY") {
   @SRVS = (@{$xml->{Package}->{Service}}); 
  } else {
   @SRVS = ($xml->{Package}->{Service});     
  }
      
  $c=0;
  foreach (@SRVS) {
    if (exists(${$_}{'Error'})) {     
     # error, probably not applicable rate to skip     
    
     print " <LI>PKG $i : Outcome From Test Package ${$_}{'ID'} Error";
     print " <LI>PKG $i Error: ${$_}{'Error'}";
     print" <LI>${${$_}{'Error'}}{'Description'} $lb and $oz and $cntry";
    
    } else {

      print qq~
<INPUT type=radio value="USPS::${$_}{'SvcDescription'}-${$_}{'Postage'}" name=shipping_type> >USPS - ${$_}{'SvcDescription'}: \$${$_}{'Postage'}
      ~;
      $scnt++;
     }
    
    }
    
    $c++;
  } 
 } 
 $i++; 
}  
}  
# END INTERNATIONAL SHIPPING


