
use LWP::UserAgent;
my $addr = 'http://production.ShippingAPIs.com/ShippingAPI.dll';
my $userid = $myconfig{usps_userid};

# request(s) Package(s)

$form->{lb} = 0 unless $form->{lb};
$form->{m_oz} = 0 unless $form->{m_oz};
$form->{c_zipcode} = $form->{zipcode} unless $form->{c_zipcode};

my $rate_req = qq|   
<RateV2Request USERID="$userid">
    <Package ID="0">
          <Service>Parcel</Service>
          <ZipOrigination>$myconfig{zip}</ZipOrigination>
          <ZipDestination>$form->{c_zipcode}</ZipDestination>
          <Pounds>$form->{lb}</Pounds>
          <Ounces>$form->{m_oz}</Ounces>
          <Container>None</Container>
          <Size>REGULAR</Size>
	  <Machinable>True</Machinable>
     </Package>
</RateV2Request>
|;

$form->{ship_req} = $rate_req;


# send request with lwp
my $ua = LWP::UserAgent->new;
$ua->timeout(2);
$ua->agent("SL-Cart/0.1 " . $ua->agent);
my $req = HTTP::Request->new(POST =>$addr);
$req->content_type('application/x-www-form-urlencoded');
$req->content('API=RateV2&XML=' . $rate_req);
my $response = $ua->request($req);

# if response, proceed
if ($response->is_success) {
my $resp = $response->content;

$form->{postage_resp} = $resp; # for debugging

my $n = (scalar(@PKGS)); #count the number of packages - for debugg mostly
#print "Displaying canned response(s) to $n Package(s) < HR > ";

use XML::Simple;
my $xml = eval{XMLin($resp)}; #set lwp response to xml

my (@PKGS,$i);
if (ref($xml->{Package}) eq "ARRAY") {
 @PKGS = (@{$xml->{Package}}); #set array to xml
} else {
 @PKGS = ($xml->{Package}); #set hash to xml
}

$i=0;
foreach (@PKGS) {
 # look for errors
 if (exists(${$_}{'Error'})) {
  
  # error, probably not applicable rate to skip
  
 } else {
  # print actual record
  unless(${$_}{'Postage'}){ next; }
  
  my $postage = ${$_}{'Postage'}{'Rate'};
  $postage += $postage * ($config{'ship_base'} / 100);
  $postage = sprintf ("%.2f",$postage);
  
  $form->{postage} = $postage;
  $cnt++;
  #print qq~
  #<INPUT type=radio value="USPS::${$_}{'Service'}-$postage" name=shipping_type$gt; USPS - ${$_}{'Service'}: \$$postage   ~; 
 }
 $scnt++;
 $i++;   
}
}

1;
