#!/usr/bin/perl

require "base.pl";
require "cart_functions.pl";

$form->{IN} = "view_cart.html";
&get_cookie_session_id;
if ($form->{action} eq "update"){
  &update_cart;
}

if ($form->{action} eq "checkout"){
  $form->{callback} = "check_out.pl";
  &redirect;
} elsif ($form->{action} eq 'logout'){
  &destroy_session;
  &redirect;
} elsif ($form->{action} eq "continue"){
  &redirect;
} else {
  require "buttons.pl";
  &get_cart_items;
  &print_screen;
}


1;

sub update_cart {
  my $dbh = $form->dbconnect(\%myconfig);
  $query = "UPDATE CART SET qty = ? WHERE session_id = ? AND parts_id = ?";
  my $sth = $dbh->prepare($query);
  for $i (1 .. $form->{rowcount}){ 
    $sth->execute($form->{"qty_$i"}, $form->{"session_id"}, $form->{"id_$i"});
  }
  $sth->finish;
  $dbh->disconnect;
}
